searchNodes=[{"doc":"","ref":"Storex.html","title":"Storex","type":"module"},{"doc":"Mutate store from elixir. Call mutation callback in store synchronously . Storex . mutate ( &quot;d9ez7fgkp96&quot; , &quot;ExampleApp.Store&quot; , &quot;reload&quot; , [ &quot;user_id&quot; ] )","ref":"Storex.html#mutate/4","title":"Storex.mutate/4","type":"function"},{"doc":"","ref":"Storex.Diff.html","title":"Storex.Diff","type":"module"},{"doc":"Check difference between two arguments. Storex.Diff . check ( %{ name : &quot;John&quot; } , %{ name : &quot;Adam&quot; } ) [ %{ a : &quot;u&quot; , p : [ :name ] , t : &quot;Adam&quot; } ] Result explanation: a : action n - none u - update d - delete i - insert t : to p : path","ref":"Storex.Diff.html#check/2","title":"Storex.Diff.check/2","type":"function"},{"doc":"","ref":"Storex.Registry.html","title":"Storex.Registry","type":"behaviour"},{"doc":"Returns store PID by session id and store id.","ref":"Storex.Registry.html#c:get_store_pid/2","title":"Storex.Registry.get_store_pid/2","type":"callback"},{"doc":"Register session PID with a session id.","ref":"Storex.Registry.html#c:register_session/2","title":"Storex.Registry.register_session/2","type":"callback"},{"doc":"Register store PID in session by id with store id.","ref":"Storex.Registry.html#c:register_store/3","title":"Storex.Registry.register_store/3","type":"callback"},{"doc":"Gets session PID by session id.","ref":"Storex.Registry.html#c:session_pid/1","title":"Storex.Registry.session_pid/1","type":"callback"},{"doc":"Return list of stores registered with session id.","ref":"Storex.Registry.html#c:session_stores/1","title":"Storex.Registry.session_stores/1","type":"callback"},{"doc":"Unregister session with a session id.","ref":"Storex.Registry.html#c:unregister_session/1","title":"Storex.Registry.unregister_session/1","type":"callback"},{"doc":"Unegister store in session by id with store id.","ref":"Storex.Registry.html#c:unregister_store/2","title":"Storex.Registry.unregister_store/2","type":"callback"},{"doc":"Registry for sessions and stores in ETS.","ref":"Storex.Registry.ETS.html","title":"Storex.Registry.ETS","type":"module"},{"doc":"Socket connection handler. Error codes: 4000 : Store is not set. 4001 : Store is not defined or can't be compiled.","ref":"Storex.Socket.html","title":"Storex.Socket","type":"module"},{"doc":"","ref":"Storex.Store.html","title":"Storex.Store","type":"behaviour"},{"doc":"Called when store session starts.","ref":"Storex.Store.html#c:init/2","title":"Storex.Store.init/2","type":"callback"},{"doc":"","ref":"Storex.Store.html#c:mutation/5","title":"Storex.Store.mutation/5","type":"callback"},{"doc":"Called when store session ends.","ref":"Storex.Store.html#c:terminate/3","title":"Storex.Store.terminate/3","type":"callback"},{"doc":"Frontend store with the state on the backend. You are able to mutate store state from the frontend and also from the backend. Whole communication going through WebSocket. Important: Storex is under active development. Report issues and send proposals here . Only diff of the store state is being sent on each mutation.","ref":"readme.html","title":"Storex","type":"extras"},{"doc":"Installation Add storex to deps in mix.exs : defp deps do [ { :storex , &quot;~&gt; 0.2.4&quot; } ] end Also you need to add storex to package.json dependencies: { &quot;storex&quot;: &quot;file:../deps/storex&quot;, } Add storex websocket handler You need to add handler Storex.Socket.Handler to cowboy dispatch. Phoenix: Example based on Phoenix guides config :exampleapp , ExampleApp.Endpoint , http : [ dispatch : [ { :_ , [ { &quot;/storex&quot; , Storex.Socket.Handler , [ ] } , { :_ , Phoenix.Endpoint.Cowboy2Handler , { ExampleApp.Endpoint , [ ] } } ] } ] ] Cowboy: :cowboy_router . compile ( [ { :_ , [ # ... { &quot;/storex&quot; , Storex.Socket.Handler , [ ] } , # ... ] } ] ) Create store To create a store you need to create new elixir module with init/2 which is called when a page is loaded, every time websocket is connected it generates session_id and passes it as the first argument, params are from Javascript store declaration. Next, you can declare mutation/5 where the first argument is mutation name, second is data passed to mutation, next two params are same like in init/2 , the last one is the current state of the store. defmodule ExampleApp.Store.Counter do use Storex.Store def init ( session_id , params ) do 0 end # `increase` is mutation name, `data` is payload from front-end, `session_id` is current session id of connecton, `initial_params` with which store was initialized, `state` is store current state. def mutation ( &quot;increase&quot; , _data , _session_id , _initial_params , state ) do state = state + 1 { :noreply , state } end def mutation ( &quot;decrease&quot; , _data , _session_id , _initial_params , state ) do state = state - 1 { :reply , &quot;message&quot; , state } end def mutation ( &quot;set&quot; , [ number ] , _session_id , _initial_params , state ) do { :noreply , number } end end Connect to store You have to connect the newly created store with a frontend side to be able to synchronise the state: params are passed as second argument in store init/2 and as third in mutation/5 . You can subscribe to changes inside store state by passing option subscribe with function as a value. import Storex from 'storex' const store = new Storex({ store: 'ExampleApp.Store.Counter', params: {}, subscribe: (state) =&gt; { console.log(state) }, connection: (state) =&gt; { console.log(state ? 'connected' : 'disconnected') } }) Mutate store You can mutate store from javascript with store instance: store.commit(&quot;increase&quot;) store.commit(&quot;decrease&quot;).then((response) =&gt; { response // Reply from elixir }) store.commit(&quot;set&quot;, 10) Or directly from elixir: Storex . mutate ( session_id , store , &quot;increase&quot; ) Storex . mutate ( session_id , store , &quot;set&quot; , [ 10 ] ) Subscribe to store state changes You can subscribe to store state changes in javascript with function subscribe: store.subscribe((state) =&gt; { const state = state }) Subscribe to store connection You can subscribe to store connection state changes in javascript with function connection: store.connection((state) =&gt; { console.log(state ? 'connected' : 'disconnected') })","ref":"readme.html#basic-usage","title":"Storex - Basic usage","type":"extras"},{"doc":"Session id generation library You can change library which generate session id for stores. Module needs to have generate/0 method. config :storex , :session_id_library , Ecto.UUID Default params You can set default params for all stores in Javascript which will be passed to store. Storex.defaults.params = { jwt: 'someJWT' } Custom store address Storex.defaults.address = 'localhost/stores'","ref":"readme.html#configuration","title":"Storex - Configuration","type":"extras"}]